part of hakkit.hakk.builder.basic;

class _ExpressionNode extends _OperatorClass
{
  static int _id = 0;
  final leftSide;
  final rightSide;
  final String operation;
  int id;
  var callParams;
  String functionName;
  _ExpressionNode(this.leftSide, this.rightSide, this.operation) : id = _id++;
  _ExpressionNode.call(this.functionName, this.callParams) : leftSide = val(0), rightSide = val(0), operation = 'call', id = _id++;
   
  void compile({clobber : false}){
    _expressionQueue.forEach((_ExpressionNode n){
      _HakkObject.addLine('$n');
    });
    
    if (clobber){
      _id = 0;
      _expressionQueue.clear();
    }
  }
  
  @override toString(){
   final ls = leftSide is _HakkObject ? '$leftSide' : '__sys__.${leftSide.id}';
   final rs = rightSide is _HakkObject ? '$rightSide' : '__sys__.${rightSide.id}';
   
   switch(operation){
     case 'call':
       if (callParams != null){
         callParams.forEach((p){
           p = _wrapLiteral(p);
           push(p);
         });
       }
       final sb = new StringBuffer();
       sb.write('call: ${functionName}${_CR}');
       sb.write('    - pop: __sys__.${id}');
       return sb.toString();
     case 'pop':
      return 'pop: __sys__.${id}';
     case 'pow':
     case 'add':
     case 'mul':
     case 'div':
     case 'sub':
      return '${operation}: [__sys__.${id}, ${ls}, ${rs}]';
     case 'rnd':
     case 'sin':
     case 'cos':
       return '${operation}: [__sys__.${id}, ${ls}]';
     case 'jl':
     case 'jg':
     case 'jle':
     case 'jge':
     case 'je':
       int li = _logicLabelIndexer++;
       final sb = new StringBuffer();
       sb.write('${operation}: [${ls}, ${rs}, __istrue_${li}__]${_CR}');
       sb.write('    - set: [__sys__.${id}, false]${_CR}');
       sb.write('    - goto: __logic_finish_${li}__${_CR}');
       sb.write('    - lbl: __istrue_${li}__${_CR}');
       sb.write('    - set: [__sys__.${id}, true]${_CR}');
       sb.write('    - lbl: __logic_finish_${li}__');
       return sb.toString();
     case '&':
       int li = _logicLabelIndexer++;
       final sb = new StringBuffer();
       sb.write('je: [${ls}, true, __istrue_${li}__]${_CR}');
       sb.write('    - set: [__sys__.${id}, false]${_CR}');
       sb.write('    - goto: __and_finish_${li}__${_CR}');
       sb.write('    - lbl: __istrue_${li}__${_CR}');
       li = _logicLabelIndexer++;
       sb.write('    - je: [${rs}, true, __istrue_${li}__]${_CR}');
       sb.write('    - set: [__sys__.${id}, false]${_CR}');
       sb.write('    - goto: __and_finish_${li}__${_CR}');
       sb.write('    - lbl: __istrue_${li}__${_CR}');    
       sb.write('    - set: [__sys__.${id}, true]${_CR}');
       sb.write('    - lbl: __and_finish_${li}__');
       return sb.toString();
     case '|':
       int li = _logicLabelIndexer++;
       final sb = new StringBuffer();
       sb.write('je: [${ls}, true, __istrue_${li}__]${_CR}');
       sb.write('    - set: [__sys__.${id}, false]${_CR}');
       sb.write('    - goto: __or_isfalse_${li}__${_CR}');
       sb.write('    - lbl: __istrue_${li}__${_CR}');
       sb.write('    - set: [__sys__.${id}, true]${_CR}');
       sb.write('    - goto: __or_finish_${li}__${_CR}');
       sb.write('    - lbl: __or_isfalse_${li}__${_CR}');
       sb.write('    - je: [${rs}, true, __istrue_${li}__]${_CR}');
       sb.write('    - set: [__sys__.${id}, false]${_CR}');
       sb.write('    - lbl: __or_finish_${li}__');
       return sb.toString();
   }
  }
}